import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import FoundationTooltipContent from './FoundationTooltipContent';

var FoundationTooltip = /*#__PURE__*/function (_React$Component) {
  _inherits(FoundationTooltip, _React$Component);

  var _super = _createSuper(FoundationTooltip);

  function FoundationTooltip(props) {
    var _this;

    _classCallCheck(this, FoundationTooltip);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "child", void 0);

    _defineProperty(_assertThisInitialized(_this), "contentEl", void 0);

    _defineProperty(_assertThisInitialized(_this), "el", void 0);

    _defineProperty(_assertThisInitialized(_this), "onMouseOver", function (evt) {
      _this.renderTooltip(evt.clientX, evt.clientY);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseMove", function (evt) {
      _this.renderTooltip(evt.clientX, evt.clientY);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseOut", function () {
      if (_this.el !== null) {
        ReactDOM.unmountComponentAtNode(_this.el);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderTooltip", function (x, y) {
      if (_this.contentEl === null) {
        return null;
      }

      var rect = _this.contentEl.getBoundingClientRect();

      var left = x - 25 - rect.left;
      var top = y - 15 - rect.top;
      ReactDOM.render( /*#__PURE__*/React.createElement(FoundationTooltipContent, {
        left: left,
        text: _this.props.text,
        top: top
      }), _this.el);
    });

    _defineProperty(_assertThisInitialized(_this), "renderTooltipWrapper", function () {
      var node = React.Children.only(_this.props.children);
      return /*#__PURE__*/React.cloneElement(node, {
        ref: function ref(c) {
          _this.child = c;

          if (typeof node.ref === 'function') {
            node.ref(c);
          }
        }
      });
    });

    _this.child = null;
    _this.contentEl = null;
    _this.el = null;
    return _this;
  }

  _createClass(FoundationTooltip, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.text === '' || this.props.text === null) {
        this.el = null;
      } else {
        this.el = document.createElement('div');
        this.contentEl = document.querySelector(this.props.tetherTo);

        if (this.contentEl !== null) {
          this.contentEl.appendChild(this.el);
        }
      }

      var node = this.child;

      if (node !== null) {
        node.addEventListener('mousemove', this.onMouseMove);
        node.addEventListener('mouseout', this.onMouseOut);
        node.addEventListener('mouseover', this.onMouseOver);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var node = this.child;

      if (node !== null) {
        node.removeEventListener('mousemove', this.onMouseMove);
        node.removeEventListener('mouseout', this.onMouseOut);
        node.removeEventListener('mouseover', this.onMouseOver);
      } // TypeScript gets confused when using optional chaining here.
      // eslint-disable-next-line @typescript-eslint/prefer-optional-chain


      if (this.el !== null && this.el.parentNode !== null) {
        this.el.parentNode.removeChild(this.el);
        this.el = null;
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.text === '' || this.props.text === null ? this.props.children : this.renderTooltipWrapper();
    }
  }]);

  return FoundationTooltip;
}(React.Component);

_defineProperty(FoundationTooltip, "defaultProps", {
  children: null,
  tetherTo: '.foundation-normalize',
  text: ''
});

export default FoundationTooltip;
//# sourceMappingURL=FoundationTooltip.js.map